'use strict';

var _actions = require('../actions');

describe('actuate() action creator', function () {
  it('should create flux standard action with type ACTUATE', function () {
    var action = (0, _actions.actuate)('f00z');
    expect(action.type).toBe(_actions.ACTUATE);
    expect(action.payload).toMatchObject({});
  });

  it('uses first arg as a name of the channel', function () {
    var action = (0, _actions.actuate)('foo');
    expect(action.payload.channel).toBe('foo');
  });

  it('puts an empty array if args are not specified', function () {
    var action = (0, _actions.actuate)('foo');
    expect(action.payload.args).toEqual([]);
  });

  it('takes event parameters', function () {
    var action = (0, _actions.actuate)('foo', 'what', 'the', 'hell');
    expect(action.payload.args).toEqual(['what', 'the', 'hell']);
  });
});