'use strict';

var _reducer = require('../reducer');

var _reducer2 = _interopRequireDefault(_reducer);

var _actions = require('../actions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var mockEngine = {};
var reducer = (0, _reducer2.default)(mockEngine);

describe('reducer', function () {
  it('should return an empty object as initial state', function () {
    expect(reducer(undefined, {})).toEqual({});
  });

  it('should handle ACTUATE action when channel is given', function () {
    var state = reducer({}, {
      type: _actions.ACTUATE,
      payload: { channel: 'm00t', timestamp: 1337 }
    });

    expect(state.m00t).toBeTruthy();
    expect(state.m00t).toMatchObject({ timestamp: 1337 });
  });

  it('should ignore action when channel is not specified', function () {
    var initialState = { someChannel: { foo: 'bar' } };
    var state = reducer(initialState, { type: _actions.ACTUATE });

    expect(state).toEqual(initialState);
  });
});