'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.actuate = exports.ACTUATE = undefined;

var _currentTimestamp = require('./utils/currentTimestamp');

// Actions
var ACTUATE = exports.ACTUATE = 'redux-actuator/ACTUATE';

var clock = 0;

var genKey = function genKey(ts, clock) {
  return ts + '::' + clock;
};

var actuate = exports.actuate = function actuate(channel) {
  for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }

  // channel has to be specified
  if (!channel) {
    var warning = 'Triggering actions without a channel is no longer ' + 'supported by `redux-actuator`. These actions will be ' + 'ingored by the actuator.';

    console.warn(warning);
  }

  var timestamp = (0, _currentTimestamp.currentTimestamp)();
  clock += 1;

  return {
    type: ACTUATE,
    payload: {
      key: genKey(timestamp, clock),
      channel: channel,
      timestamp: timestamp,
      args: args
    }
  };
};