'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Actuator = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRedux = require('react-redux');

var _currentTimestamp = require('../utils/currentTimestamp');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Actuator = exports.Actuator = function (_React$Component) {
  _inherits(Actuator, _React$Component);

  function Actuator(props, context) {
    _classCallCheck(this, Actuator);

    // Used to store last visible keys on per-channel basis
    // format channel -> last key
    var _this = _possibleConstructorReturn(this, (Actuator.__proto__ || Object.getPrototypeOf(Actuator)).call(this, props, context));

    _this._keyCache = {};
    return _this;
  }

  _createClass(Actuator, [{
    key: 'getChanHandlers',
    value: function getChanHandlers() {
      var _props = this.props,
          on = _props.on,
          channel = _props.channel;


      if (typeof on === 'function') {
        return _defineProperty({}, channel, on);
      }

      return on;
    }
  }, {
    key: 'getObservedChannels',
    value: function getObservedChannels() {
      return Object.keys(this.getChanHandlers());
    }
  }, {
    key: 'onStateChanged',
    value: function onStateChanged() {
      var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

      state = state || this.context.store.getState();
      if (!state.actuator) return null;

      var channels = this.getObservedChannels();

      for (var _len = arguments.length, restOpts = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        restOpts[_key - 1] = arguments[_key];
      }

      for (var i = 0; i < channels.length; ++i) {
        var chan = channels[i];
        var event = state.actuator[chan];

        if (!event) continue;
        this.checkEvent.apply(this, [chan, event].concat(restOpts));
      }
    }
  }, {
    key: 'callChanHandler',
    value: function callChanHandler(channel, args) {
      var handlers = this.getChanHandlers();
      handlers[channel] && handlers[channel].apply(handlers, _toConsumableArray(args));
    }
  }, {
    key: 'checkEvent',
    value: function checkEvent(channel, event) {
      var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

      // Compare event keys (they have to be unique)
      var _prevKey = this._keyCache[channel];
      if (_prevKey && _prevKey === event.key) {
        return;
      }

      this._keyCache[channel] = event.key;

      // Special case when the event was dispatched before
      // the mount. If you need to handle cases like
      // this one, pass `deltaError` prop, which literally means:
      // "handle missed events on mount if it's younger than `deltaError`"
      var shouldHandleOnMount = false;
      var deltaError = this.props.deltaError;


      if (options.onMount && deltaError) {
        var now = (0, _currentTimestamp.currentTimestamp)();
        var delta = Math.abs(now - event.timestamp);

        shouldHandleOnMount = delta <= deltaError;
      }

      if (options.onMount && !shouldHandleOnMount) {
        return;
      }

      this.callChanHandler(channel, event.args);
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      var store = this.context.store;

      if (store) {
        this._sub = store.subscribe(function () {
          return _this2.onStateChanged();
        });

        // trigger on mount check
        var state = store.getState();
        this.onStateChanged(state, { onMount: true });
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this._sub && this._sub();
    }
  }, {
    key: 'render',
    value: function render() {
      if (!this.props.children) return null;
      return this.props.children;
    }
  }]);

  return Actuator;
}(_react2.default.Component);

Actuator.propTypes = {
  channel: _propTypes2.default.string,

  on: _propTypes2.default.oneOfType([
  // Can be simple event handler of a map of handlers
  // e.g. { chanOne: ..., chanTwo: ... }
  _propTypes2.default.func, _propTypes2.default.objectOf(_propTypes2.default.func)]).isRequired,

  deltaError: _propTypes2.default.number,

  // Always require `channel` prop, unless the map
  // of listeners wasn't passed with `on` prop.
  _requireChannel: function _requireChannel(props) {
    var isMapOfHandlers = props.on !== null && _typeof(props.on) === 'object';

    if (!props.channel && !isMapOfHandlers) {
      return new Error('channel is required');
    }
  }
};

Actuator.contextTypes = {
  store: _propTypes2.default.object
};

exports.default = Actuator;